#include <iostream> 
#include <string> 
using namespace std; 
#include <WiFi.h>
#include <HTTPClient.h>
#include <ArduinoJson.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <esp_now.h>
#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);


const char* ssid = "Filmboard";
const char* password = "FilmFilm";


const char* servermode = "http://192.168.4.1/modes";
const char* humidity = "http://192.168.4.1/humiditys";
const char* ldr = "http://192.168.4.1/ldrs";
const char* thermo = "http://192.168.4.1/thermos";

String temperature;


unsigned long previousMillis = 0;
const long interval = 500; 

void setup() {
  pinMode(pin, OUTPUT);
  pinMode(pin, HIGH);
  Serial.begin(115200);
  WiFi.begin(ssid, password);
  Serial.println("Connecting");
  while(WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print("..");
  }
  Serial.println("");
  Serial.print("Connected to WiFi network with IP Address: ");
  Serial.println(WiFi.localIP());

  Serial.begin(115200);

  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  display.clearDisplay();

  display.setTextSize(1.95);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  /*delay(500);
  // Display static text
  display.println("temperature");
  display.println(temperature);
  display.display(); */
}

void loop() {
  unsigned long currentMillis = millis();
  if(currentMillis - previousMillis >= interval) {
//    Serial.printf("come inside --------------------------------");
     // Check WiFi connection status
    if(WiFi.status()== WL_CONNECTED ){ 
      String servermode_value = httpGETRequest(servermode);
      String humidity_value = httpGETRequest(humidity);
      String ldr_value= httpGETRequest(ldr);
      String thermo_value =  httpGETRequest(thermo);
      Serial.println("mode: " + servermode_value);
      Serial.println("Humidity: " + humidity_value);
      display.clearDisplay();
      display.setCursor(0, 10);
      //display.println(servermode_value);
      display.print("HUMIDITY:");
      display.println(humidity_value);
      display.println("");
      display.print("IDR:");
      display.println(ldr_value);
      display.println("");
      display.print("THERMO:");
      display.println(thermo_value);
      display.println("");
      display.display();
      delay(500);
    
//      Serial.printf("come inside --------------------------------");

      int x=1;
//      if (x > 40){
//        WiFi.disconnect(true);
//        WiFi.mode(WIFI_OFF);
//        Serial.println("disconnect from board");
//
//        WiFi.begin(SSIDS, password);
//        Serial.println("Connecting poomphat wifi");
//        WiFi.begin(SSIDS, password);
//        while(WiFi.status() != WL_CONNECTED) { 
//          delay(500);
//          Serial.print("#");
//        }
//        Serial.println("");
//        Serial.print("Connected to WiFi network with IP Address: ");
//        Serial.println(WiFi.localIP());
//        HTTPClient http;
//        String request = "https://notify-api.line.me/api/notify";
//        http.begin(request);
//        http.addHeader("Content-Type", "application/x-www-form-urlencoded");
//        http.addHeader("Authorization", "Bearer 1qLYbor5GOOBIcI6UJ0XllnrUURdOpQfzaXES978RQb");
//        int httpCode = http.POST("message=HELLO FROM CLIENT");
//        Serial.println(httpCode);
//        WiFi.disconnect(true);
//        WiFi.begin(ssid, password);
//        Serial.println("Connecting");
//        while(WiFi.status() != WL_CONNECTED) {
//          delay(500);
//          Serial.print(".");
//        }
//        Serial.println("");
//        Serial.print("Connected to WiFi network with IP Address: ");
//        Serial.println(WiFi.localIP());
//      }
      
      

      
      // save the last HTTP GET Request
      previousMillis = currentMillis;
    }
    else {
      Serial.println("WiFi Disconnected");
    }
  }
}

String httpGETRequest(const char* serverName) {
  HTTPClient http;
    
  // Your IP address with path or Domain name with URL path 
  http.begin(serverName);
  
  // Send HTTP POST request
  int httpResponseCode = http.GET();
  
  String payload = "--"; 
  
  if (httpResponseCode>0) {
    Serial.print("HTTP Response code: ");
    Serial.println(httpResponseCode);
    payload = http.getString();
  }
  else {
    Serial.print("Error code: ");
    Serial.println(httpResponseCode);
  }
  // Free resources
  http.end();

  return payload;
}