#include <WiFi.h>
#include <HTTPClient.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
//#include <esp_now.h>
#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

const char* ssid = "iPhone";
const char* password = "ham12345";

const char* ssid2 = "Filmboard";
const char* password2 = "FilmFilm";
const char* ntpServer = "pool.ntp.org";
const long  gmtOffset_sec = 21600;
const int   daylightOffset_sec = 3600;

struct tm timeinfo;

const int buzzer = 0;

const char* servermode = "http://192.168.4.1/modes";
const char* humidity = "http://192.168.4.1/humiditys";
const char* ldr = "http://192.168.4.1/ldrs";
const char* thermo = "http://192.168.4.1/thermos";
const char* hour = "http://192.168.4.1/hour";
const char* minutes = "http://192.168.4.1/minutes";

String temperature;

int* localhour;
int* localminute;
int* localsec;

void LineNoti(){
  Serial.println("GET REQUEST");
  if(WiFi.status() == WL_CONNECTED){
    Serial.println("connected");
  }
  HTTPClient http;
  http.begin("https://notify-api.line.me/api/notify");
  http.addHeader("Content-Type", "application/x-www-form-urlencoded");
  http.addHeader("Authorization", "Bearer 1qLYbor5GOOBIcI6UJ0XllnrUURdOpQfzaXES978RQb");
//  String str_humidity = String(real_humidity);
//  String str_ldr = String(LDR);
//  String str_thermo = String(T);
//  String linenoti = message+text1+text2+str_humidity+"\n"+text3+str_ldr+"\n"+text4+str_thermo+" c";
  String linenoti = "message=ถึงเวลาสดชื่นแล้ววว !!!!";
  int httpCode = http.POST(linenoti);
  Serial.println(httpCode);
  http.end();
}

void printLocalTime()
{
  if(!getLocalTime(&timeinfo)){
    Serial.println("Failed to obtain time");
    return;
  }

}
void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  pinMode(buzzer,OUTPUT);
  digitalWrite(buzzer,HIGH);

  //connect to WiFi
  Serial.printf("Connecting to %s ", ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
  }
  Serial.println(" CONNECTED Wifi \n");

  //init and get the time
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);
  printLocalTime();

  //disconnect WiFi as it's no longer needed
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
  Serial.printf("Disconnected Wifi \n");

  //////////////////////////////////////////////////////////////////////
  WiFi.persistent(false);
  WiFi.mode(WIFI_OFF);   // this is a temporary line, to be removed after SDK update to 1.5.4
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid2, password2);
  Serial.println("Connecting");
  while(WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to WiFi network with IP Address: ");
  Serial.println(WiFi.localIP());


  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  display.clearDisplay();

  display.setTextSize(1.95);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
}

void loop() {
  // put your main code here, to run repeatedly:
  if(WiFi.status() == WL_CONNECTED) {
//    Serial.printf("come inside --------------------------------");
     // Check WiFi connection status
    Serial.println("OUTTTTTTTTTTTTTTTTT");
    if(WiFi.status() == WL_CONNECTED ){ 
      String servermode_value = httpGETRequest(servermode);
      String humidity_value = httpGETRequest(humidity);
      String ldr_value= httpGETRequest(ldr);
      String thermo_value =  httpGETRequest(thermo);
      String hour_value =  httpGETRequest(hour);
      String minutes_value =  httpGETRequest(minutes);
      Serial.println("mode: " + servermode_value);
      Serial.println("Humidity: " + humidity_value);
      Serial.println("Hour: " + hour_value);
      Serial.println("Minute: " + minutes_value);
      display.clearDisplay();
      display.setCursor(0, 10);
      //display.println(servermode_value);
//      display.print("HUMIDITY:");
//      display.println(humidity_value);
//      display.println("");
//      display.print("IDR:");
//      display.println(ldr_value);
//      display.println("");
//      display.print("THERMO:");
//      display.println(thermo_value);
//      display.println("");
      display.print("TIME : ");
      display.print(hour_value);
      display.print(":");
      display.print(minutes_value);
      display.println("");
      printLocalTime();
      display.println("");
      display.print("LOCAL TIME : ");
      display.print(*&timeinfo.tm_hour);
      display.print(":");
      display.print(*&timeinfo.tm_min);
      display.print(":");
      display.print(*&timeinfo.tm_sec);
      display.println("");
      display.display();
      if(servermode_value=="MODE 1"){
        if(hour_value==String(*&timeinfo.tm_hour)){
          if(minutes_value==String(*&timeinfo.tm_min)){
            if((String(*&timeinfo.tm_sec)).toInt()==59){
              digitalWrite(buzzer,LOW);
              delay(300);
              digitalWrite(buzzer,HIGH);
              delay(300);
              digitalWrite(buzzer,LOW);
              delay(300);
              digitalWrite(buzzer,HIGH);
              delay(300);
              digitalWrite(buzzer,LOW);
              delay(300);
              digitalWrite(buzzer,HIGH);
              delay(300);
              display.println("");
              display.println("");
              display.print("    TIME TO FRESH");
              display.display();
              WiFi.disconnect(true);
              WiFi.mode(WIFI_OFF);
              Serial.printf("Disconnected Wifi \n");
            
              //////////////////////////////////////////////////////////////////////
              WiFi.persistent(false);
              WiFi.mode(WIFI_OFF);   // this is a temporary line, to be removed after SDK update to 1.5.4
              WiFi.mode(WIFI_STA);
              WiFi.begin(ssid, password);
              Serial.println("Connecting");
              while(WiFi.status() != WL_CONNECTED) {
                delay(500);
                Serial.print(".");
              }
              LineNoti();
              WiFi.disconnect(true);
              WiFi.mode(WIFI_OFF);
              Serial.printf("Disconnected Wifi \n");
            
              //////////////////////////////////////////////////////////////////////
              WiFi.persistent(false);
              WiFi.mode(WIFI_OFF);   // this is a temporary line, to be removed after SDK update to 1.5.4
              WiFi.mode(WIFI_STA);
              WiFi.begin(ssid2, password2);
              Serial.println("Connecting");
              while(WiFi.status() != WL_CONNECTED) {
                delay(500);
                Serial.print(".");
              }
              
            }
          }
        }
      }
      else{
        if(humidity_value.toInt() < 3000)
        {
          digitalWrite(buzzer,LOW);
          delay(300);
          digitalWrite(buzzer,HIGH);
          delay(300);
          digitalWrite(buzzer,LOW);
          delay(300);
          digitalWrite(buzzer,HIGH);
          delay(300);
          digitalWrite(buzzer,LOW);
          delay(300);
          digitalWrite(buzzer,HIGH);
          delay(300);
        }
      }
//      delay(500);
    }
    else {
      Serial.println("WiFi Disconnected");
    }
  }
}

String httpGETRequest(const char* serverName) {
  HTTPClient http;
    
  // Your IP address with path or Domain name with URL path 
  http.begin(serverName);
  
  // Send HTTP POST request
  int httpResponseCode = http.GET();
  
  String payload = "--"; 
  
  if (httpResponseCode>0) {
    Serial.print("HTTP Response code: ");
    Serial.println(httpResponseCode);
    payload = http.getString();
  }
  else {
    Serial.print("Error code: ");
    Serial.println(httpResponseCode);
  }
  // Free resources
  http.end();

  return payload;
}