#include <AsyncTCP.h>
#include <HTTPClient.h>
#include <AsyncEventSource.h>
//#include <AsyncJson.h>
#include <AsyncWebSocket.h>
#include <AsyncWebSynchronization.h>
#include <ESPAsyncWebServer.h>
#include <SPIFFSEditor.h>
#include <StringArray.h>
#include <WebAuthentication.h>
#include <WebHandlerImpl.h>
#include <WebResponseImpl.h>
#include "soc/rtc_wdt.h"
#include "esp_int_wdt.h"
#include "esp_task_wdt.h"

#include <TimeLib.h>
#include <time.h>
#include <WiFi.h>

#define sethr_pin 16
#define setmin_pin 17
#define start_pin 5
#define plusdur_pin 18
#define minusdur_pin 19
#define pump_pin 27

int Alarmset;
int Alarm;

int setButtonState = 0;
int alarmHRPushCounter =0;
int alarmMinPushCounter =0;
int durcounter=0;
int pumpstat = 0;

volatile unsigned long DebounceTimer=0;
volatile unsigned long lastDebounceTime=0;
volatile unsigned int delayTime = 300;

const char* wifissid       = "hello";
const char* wifipassword   = "1234567890";
//-------------for localtime------------
//const char* ntpServer = "pool.ntp.org";
//const long  gmtOffset_sec = 21600;
//const int   daylightOffset_sec = 3600;
//struct tm timeinfo;
//void printLocalTime()
//{
//  if(!getLocalTime(&timeinfo)){
//    Serial.println("Failed to obtain time");
//    return;
//  }
//  Serial.println(&timeinfo, "%A, %B %d %Y %H:%M:%S");}
//----------------End For localtime------------------

//serverID/Pass
const char* ssid = "Filmboard";
const char* password = "FilmFilm";

// Create AsyncWebServer object on port 80
AsyncWebServer server(80);
String httpGETRequest(const char* serverName) {
  HTTPClient http;

  // Your IP address with path or Domain name with URL path 
  http.begin(serverName);

  // Send HTTP POST request
  int httpResponseCode = http.GET();

  String payload = "--"; 

  if (httpResponseCode>0) {
    Serial.print("HTTP Response code: ");
    Serial.println(httpResponseCode);
    payload = http.getString();
  }
  else {
    Serial.print("Error code: ");
    Serial.println(httpResponseCode);
  }
  // Free resources
  http.end();

  return payload;
}
String Hrstat() {
  return String(alarmHRPushCounter);
  //return String(1.8 * bme.readTemperature() + 32);
}
String Minstat() {
  return String(alarmMinPushCounter);
  //return String(1.8 * bme.readTemperature() + 32);
}
String Durstat() {
  return String(durcounter);
}
String Pumpstat() {
  return String(pumpstat);
}
String Modestat() {
  while (WiFi.status() == WL_CONNECTED) {
  return httpGETRequest("http://10.10.2.6/mode");
  }

}
String Humstat() {
  while (WiFi.status() == WL_CONNECTED) {
  return httpGETRequest("http://10.10.2.6/humidity");
  }
}
String Ldrstat() {
  while (WiFi.status() == WL_CONNECTED) {
  return httpGETRequest("http://10.10.2.6/ldr");
  }
}
String Thstat() {
  while (WiFi.status() == WL_CONNECTED) {
  return httpGETRequest("http://10.10.2.6/thermos");
  }
}


void setup() {
  Serial.begin(115200);
  pinMode(sethr_pin,INPUT);
  pinMode(setmin_pin,INPUT);
  pinMode(start_pin,INPUT);
  pinMode(plusdur_pin,INPUT);
  pinMode(minusdur_pin,INPUT);
  pinMode(pump_pin,INPUT);
  
//--------------------------------------------------------------------------
  WiFi.begin(wifissid, wifipassword);
  while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
  }
  Serial.println(" CONNECTED");
  Serial.println(httpGETRequest("http://10.10.2.6/mode"));
  disconnect WiFi as it's no longer needed
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
//---------------------//end wifisetup-------------------------------------

  // Setting the ESP as an access point
  Serial.print("Setting AP (Access Point)â€¦");
  // Remove the password parameter, if you want the AP (Access Point) to be open
  WiFi.softAP(ssid, password);

  IPAddress IP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(IP);

  Serial.println(httpGETRequest("http://10.10.2.6/mode"));
  server.on("/hour", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Hrstat()).c_str());
  });
  server.on("/minutes", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Minstat()).c_str());
  });
  server.on("/Duration", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Durstat()).c_str());
  });
  server.on("/mode_pump", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Pumpstat()).c_str());
  });
  server.on("/modes", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Modestat()).c_str());
  });
  server.on("/humiditys", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Humstat()).c_str());
  });
  server.on("/ldrs", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Ldrstat()).c_str());
  });
  server.on("/thermos", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", String(Thstat()).c_str());
  });  
  server.begin();
//---------------------//end serversetup-------------------------------------
}

void loop() {  
  attachInterrupt(digitalPinToInterrupt(16),  hrcount , FALLING);
  attachInterrupt(digitalPinToInterrupt(17),  mincount , FALLING);
  attachInterrupt(digitalPinToInterrupt(5),   startcount , FALLING);
  attachInterrupt(digitalPinToInterrupt(18),  plusdur, FALLING);
  attachInterrupt(digitalPinToInterrupt(19),  minusdur , FALLING);
  attachInterrupt(digitalPinToInterrupt(27),  Pumpstatus , FALLING);

  Serial.println(alarmHRPushCounter);
  Serial.println(alarmMinPushCounter);
  Serial.println(durcounter);
  Serial.println(pumpstat);
  delay(1000);
}

//-------------//Function-----------------
   void hrcount(){
   if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      alarmHRPushCounter ++; 
      if (alarmHRPushCounter == 24){
        alarmHRPushCounter = 0;
      }}}
  void mincount(){
   if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      alarmMinPushCounter ++; 
      if (alarmMinPushCounter == 60){
        alarmMinPushCounter = 0;
      }}}
   void startcount(){
   if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      if (Alarmset==0){
        Alarmset=1;
        Serial.printf("Alarm has been set at %d %d \n", alarmHRPushCounter,  alarmMinPushCounter);
   }
      else if(Alarmset==1){
        Alarmset=0;
        Serial.printf("Alarm unset \n");
  }}}
  void plusdur(){
      if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      durcounter++;
      if(durcounter==11){
        durcounter=0;
      }}}
  void minusdur(){
      if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      durcounter--;
       if(durcounter==-1){
        durcounter=10;
      }}}
    void Pumpstatus(){
      if ((millis() - lastDebounceTime) > delayTime) {
      lastDebounceTime=millis();
      if (pumpstat==0){
        pumpstat=1;
      }
      else if (pumpstat==1){
        pumpstat=0;
      }}}
