#include <WiFi.h>
#include <ESPAsyncWebServer.h>
#include <HTTPClient.h>
#include <ArduinoJson.h>
#include <esp_now.h>

//String response = "";

uint8_t broadcastAddress1[] = {0x24, 0x0A, 0xC4, 0x9B, 0x15, 0xF0};
//เครื่องแฮม 24:0A:C4:9B:15:F0

DynamicJsonDocument doc(2048);
#define SSID        "hello"
#define PASSWORD    "1234567890"
#define buzzer 0

IPAddress IP = IPAddress (10, 10, 2, 6);
IPAddress gateway = IPAddress (10, 10, 2, 8);
IPAddress NMask = IPAddress (255, 255, 255, 0);

AsyncWebServer server(80);

int delaytime;
int soil = 34;
int ldr = 36;
int ThermistorPin = 35;
int Vo;
float R1 = 10000;
float R2, T;
int rocker = 4;
int rocker_state = 0;
int real_humidity;
int LDR;
String rocker_mode = "MODE 1";
String message = "message=";
String text1 = "ความชื้นน้อยกว่ากำหนด:กำลังรดน้ำ\n";
String text2 = "ค่าความชื้น:";
String text3 = "ค่าความเข้มเเสง:";
String text4 = "ค่าอุณหภูมิ:";

String readThermo(){
  int ThermisTorRead = analogRead(ThermistorPin);
  float VPA0 = (ThermisTorRead*3.3)/4096;
  R2 = 3.3*(R1/VPA0)-R1;
  T = 4050/log(R2/0.0126080844)-273;
  
  Serial.print(T);
  Serial.println(" c");
  return(String(T));
}

String readHumidity(){
  int Humidity = analogRead(soil);
  real_humidity = Humidity - 4095;
  if(real_humidity < 0){
    real_humidity = real_humidity * -1;
  }
  if((real_humidity<500)&&(millis()-delaytime)>10000&&rocker_state==HIGH){
    Serial.println("ความชื้นมีค่าน้อย");
    LineNoti();
    delaytime = millis();
  }
  Serial.println(real_humidity);
  return(String(real_humidity));
}

String readLDR(){
  LDR = analogRead(ldr);
  Serial.println(LDR);
  return(String(LDR));
}

String readRocker(){
  rocker_state = digitalRead(rocker);
  if(rocker_state == LOW){ //mode1
    rocker_mode = "MODE 1";
    Serial.println(rocker_mode);
    return(String(rocker_mode));
  }
  else{ //mode2
    rocker_mode = "MODE 2";
    Serial.println(rocker_mode);
    return(String(rocker_mode));
  }
}

void LineNoti(){
  Serial.println("GET REQUEST");
  if(WiFi.status() == WL_CONNECTED){
    Serial.println("connected");
  }
  HTTPClient http;
  http.begin("https://notify-api.line.me/api/notify");
  http.addHeader("Content-Type", "application/x-www-form-urlencoded");
  http.addHeader("Authorization", "Bearer 1qLYbor5GOOBIcI6UJ0XllnrUURdOpQfzaXES978RQb");
  String str_humidity = String(real_humidity);
  String str_ldr = String(LDR);
  String str_thermo = String(T);
  String linenoti = message+text1+text2+str_humidity+"\n"+text3+str_ldr+"\n"+text4+str_thermo;
  int httpCode = http.POST(linenoti);
  Serial.println(httpCode);
  http.end();  
}

void setup() {
  Serial.begin(115200);
  WiFi.begin("iPhone","ham12345");
  while(WiFi.status()!= WL_CONNECTED){
    Serial.print(".");
    delay(400);
  }
  pinMode(soil,INPUT);
  pinMode(rocker,INPUT);
  pinMode(buzzer, OUTPUT);
  WiFi.softAP(SSID,PASSWORD);

  WiFi.softAPConfig(IP,IP,NMask);

  IPAddress IP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(IP);

  server.on("/humidity",HTTP_GET,[](AsyncWebServerRequest *request){
    request->send_P(200,"text/plain",readHumidity().c_str());
  });

  server.on("/mode",HTTP_GET,[](AsyncWebServerRequest *request){
    request->send_P(200,"text/plain",readRocker().c_str());
  });

  server.on("/ldr",HTTP_GET,[](AsyncWebServerRequest *request){
    request->send_P(200,"text/plain",readLDR().c_str());
  });

  server.on("/thermo",HTTP_GET,[](AsyncWebServerRequest *request){
    request->send_P(200,"text/plain",readThermo().c_str());
  });
  
  server.begin();
}

void loop() {
  
}